<template>
    <div>
        <div v-if="$store.state.user.photos.profile" style="margin-top: 20px;">
            <p>Główne zdjęcie profilowe</p>
            <img :src="$store.state.user.photos.profile" height="150px" width="auto" />
            <v-dialog v-model="changePhotoDialog" width="500">
                <template v-slot:activator="{ on, attrs }">
                    <v-btn @click="changeProfilePhoto" style="margin-left: 20px;" color="primary" dark v-bind="attrs"
                        v-on="on">
                        Zmień zdjęcie
                    </v-btn>
                </template>

                <v-card>
                    <v-card-title class="text-h5 grey lighten-2">
                        <p v-if="changedPhotoState.profile">
                            Zmień główne zdjęcie profilowe
                        </p>
                        <p v-if="!changedPhotoState.profile && changedPhotoState.add">
                            Dodaj zdjęcie
                        </p>
                        <p v-if="!changedPhotoState.profile && !changedPhotoState.add">
                            Zmień zdjęcie
                        </p>

                    </v-card-title>

                    <v-card-text style="display: flex; justify-content: center;">
                        <UploadImage ref="uploader" />
                    </v-card-text>

                    <v-divider></v-divider>

                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="primary" text @click="changePhoto">
                            OK
                        </v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>
        </div>
        <v-btn @click="addPhoto"
            :style="{ position: 'relative', left: $store.state.user.photos.rest.length > 0 ? '168px' : '0px', top: $store.state.user.photos.rest.length > 0 ? '20px' : '0px', 'margin-bottom': '12px' }"
            color="primary" dark v-bind="attrs" v-on="on">
            Dodaj zdjęcie
        </v-btn>
        <div style="position: relative; top:40px;">


            <div v-for="(image, index) in $store.state.user.photos.rest" :key="index"
                style="display: block; width: 150px; float: left; margin: 15px;">
                <v-img height="150px" width="auto" :src="$store.state.user.photos.rest[index]">
                </v-img>
                <v-btn color="primary" text @click="() => { removeRestPhoto(index) }">usuń</v-btn>
                <v-btn color="primary" text @click="() => { changeRestPhoto(index) }">zmień</v-btn>
            </div>
        </div>
    </div>
</template>
<script>
export default {
    data() {
        return {
            changePhotoDialog: false,
            changedPhotoState: {
                profile: true,
                add: true,
                index: -1
            }
        }
    },
    methods: {
        changeProfilePhoto() {
            this.changedPhotoState = {
                profile: true,
                add: false,
            }
        },
        addPhoto() {
            this.changedPhotoState = {
                profile: false,
                add: true,
            }
            this.changePhotoDialog = true;
        },
        changePhoto() {
            const image = this.$refs.uploader.$refs.uploader.images[0]?.path;

            if (this.changedPhotoState.profile) {
                if (image) this.$store.dispatch('changeProfilePhoto', image);
            };

            if (!this.changedPhotoState.profile && this.changedPhotoState.add) {
                if (image) this.$store.dispatch('addRestImage', image);
            };

            if (!this.changedPhotoState.profile && !this.changedPhotoState.add) {
                if (image) this.$store.dispatch('replaceRestImage', { image, index: this.changedPhotoState.index, profile: this.changeRestPhoto.profileindex, profile: this.changeRestPhoto.profile });
            };

            this.$refs.uploader.$refs.uploader.images = [];
            this.changePhotoDialog = false;
        },

        removeRestPhoto(index) {
            this.$store.dispatch('removeRestImage', index);
        },

        changeRestPhoto(index) {
            this.changedPhotoState = {
                profile: false,
                add: false,
                index
            };
            this.changePhotoDialog = true;
        }
    }
}
</script>